Skip to main content
Docs

Clerk billing for B2C SaaS

Warning

Billing is currently in Beta and its APIs are experimental and may undergo breaking changes. To mitigate potential disruptions, we recommend pinning your SDK and clerk-js package versions.

Clerk billing for B2C SaaS allows you to create plans and manage subscriptions for individual users in your application. If you'd like to charge companies or organizations, see Billing for B2B SaaS. You can also combine both B2C and B2B billing in the same application.

Enable billing

To enable billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling billing for your application.

Clerk Billing costs the same as using Stripe Billing directly, just 0.7% per transaction, plus transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.

Payment gateway

Once you have enabled billing, you will see the following Payment gateway options for collecting payments via Stripe:

  • Clerk development gateway: A shared test Stripe account used for development instances. This allows developers to test and build billing flows in development without needing to create and configure a Stripe account.
  • Stripe account: Use your own Stripe account for production. A Stripe account created for a development instance cannot be used for production. You will need to create a separate Stripe account for your production environment.

Create a plan

Subscription plans are what your users subscribe to. There is no limit to the number of plans you can create.

To create a plan, navigate to the Plans page in the Clerk Dashboard. Here, you can create, edit, and delete plans. To setup B2C billing, select the Plans for Users tab and select Add Plan. When creating a plan, you can also create features for the plan; see the next section for more information.

Tip

What is the Publicly available option?

Add features to a plan

Features make it easy to give entitlements to your plans. You can add any number of features to a plan.

You can add a feature to a plan when you are creating a plan. To add it after a plan is created:

  1. Navigate to the Plans page in the Clerk Dashboard.
  2. Select the plan you'd like to add a feature to.
  3. In the Features section, select Add Feature.

Tip

What is the Publicly available option?

Create a pricing page

You can create a pricing page by using the <PricingTable /> component. This component displays a table of plans and features that users can subscribe to. It's recommended to create a dedicated page, as shown in the following example.

src/screens/pricing.tsx
import { PricingTable } from '@clerk/clerk-react'

export default function PricingScreen() {
  return (
    <div style={{ maxWidth: '800px', margin: '0 auto', padding: '0 1rem' }}>
      <PricingTable />
    </div>
  )
}

Control access with features and plans

You can use Clerk's features and plans to gate access to the content. There are a few ways to do this, but the recommended approach is to either use the has()Clerk Icon method or the <Protect> component.

The has() method is available for any JavaScript framework, while <Protect> is only available for React-based frameworks.

Example: Using has()

Use the has() method to test if the user has access to a plan:

const hasPremiumAccess = has({ plan: 'gold' })

Or a feature:

const hasPremiumAccess = has({ feature: 'widgets' })

The has()Clerk Icon method is a server-side helper that checks if the organization has been granted a specific type of access control (role, permission, feature, or plan) and returns a boolean value. has() is available on the auth objectClerk Icon, which you will access differently depending on the framework you are usingClerk Icon.

The following example demonstrates how to use has() to check if a user has a plan.

src/pages/bronze-content.tsx
import { useAuth } from '@clerk/clerk-react'

export default function BronzeContentPage() {
  const { has, isLoaded } = useAuth()

  if (!isLoaded) return <div>Loading...</div>

  const hasBronzePlan = has({ plan: 'bronze' })

  if (!hasBronzePlan) return <h1>Only subscribers to the Bronze plan can access this content.</h1>

  return <h1>For Bronze subscribers only</h1>
}

The following example demonstrates how to use has() to check if a user has a feature.

src/pages/premium-content.tsx
import { useAuth } from '@clerk/clerk-react'

export default function PremiumContentPage() {
  const { isLoaded, has } = useAuth()

  if (!isLoaded) return <div>Loading...</div>

  const hasPremiumAccess = has({ feature: 'premium_access' })

  if (!hasPremiumAccess)
    return <h1>Only subscribers with the Premium Access feature can access this content.</h1>

  return <h1>Our Exclusive Content</h1>
}

Example: Using <Protect>

The <Protect> component protects content or even entire routes by checking if the user has been granted a specific type of access control (role, permission, feature, or plan). You can pass a fallback prop to <Protect> that will be rendered if the user does not have the access control.

The following example demonstrates how to use <Protect> to protect a page by checking if the user has a plan.

src/pages/protected-content.tsx
import { Protect } from '@clerk/clerk-react'

export default function ProtectedContentPage() {
  return (
    <Protect
      plan="bronze"
      fallback={<p>Only subscribers to the Bronze plan can access this content.</p>}
    >
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Protect>
  )
}

The following example demonstrates how to use <Protect> to protect a page by checking if the user has a feature.

src/pages/protected-premium-content.tsx
import { Protect } from '@clerk/clerk-react'

export default function ProtectedPremiumContentPage() {
  return (
    <Protect
      feature="premium_access"
      fallback={<p>Only subscribers with the Premium Access feature can access this content.</p>}
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Protect>
  )
}

Feedback

What did you think of this content?

Last updated on

Skip to main content
Docs

Clerk billing for B2C SaaS

Warning

Billing is currently in Beta and its APIs are experimental and may undergo breaking changes. To mitigate potential disruptions, we recommend pinning your SDK and clerk-js package versions.

Clerk billing for B2C SaaS allows you to create plans and manage subscriptions for individual users in your application. If you'd like to charge companies or organizations, see Billing for B2B SaaS. You can also combine both B2C and B2B billing in the same application.

Enable billing

To enable billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling billing for your application.

Clerk Billing costs the same as using Stripe Billing directly, just 0.7% per transaction, plus transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.

Payment gateway

Once you have enabled billing, you will see the following Payment gateway options for collecting payments via Stripe:

  • Clerk development gateway: A shared test Stripe account used for development instances. This allows developers to test and build billing flows in development without needing to create and configure a Stripe account.
  • Stripe account: Use your own Stripe account for production. A Stripe account created for a development instance cannot be used for production. You will need to create a separate Stripe account for your production environment.

Create a plan

Subscription plans are what your users subscribe to. There is no limit to the number of plans you can create.

To create a plan, navigate to the Plans page in the Clerk Dashboard. Here, you can create, edit, and delete plans. To setup B2C billing, select the Plans for Users tab and select Add Plan. When creating a plan, you can also create features for the plan; see the next section for more information.

Tip

What is the Publicly available option?

Add features to a plan

Features make it easy to give entitlements to your plans. You can add any number of features to a plan.

You can add a feature to a plan when you are creating a plan. To add it after a plan is created:

  1. Navigate to the Plans page in the Clerk Dashboard.
  2. Select the plan you'd like to add a feature to.
  3. In the Features section, select Add Feature.

Tip

What is the Publicly available option?

Create a pricing page

You can create a pricing page by using the <PricingTable /> component. This component displays a table of plans and features that users can subscribe to. It's recommended to create a dedicated page, as shown in the following example.

pages/pricing.vue
<script setup lang="ts">
import { PricingTable } from '@clerk/vue'
</script>

<template>
  <main>
    <PricingTable />
  </main>
</template>

Control access with features and plans

You can use Clerk's features and plans to gate access to the content. There are a few ways to do this, but the recommended approach is to either use the has()Clerk Icon method or the <Protect> component.

The has() method is available for any JavaScript framework, while <Protect> is only available for React-based frameworks.

Example: Using has()

Use the has() method to test if the user has access to a plan:

const hasPremiumAccess = has({ plan: 'gold' })

Or a feature:

const hasPremiumAccess = has({ feature: 'widgets' })

The has()Clerk Icon method is a server-side helper that checks if the organization has been granted a specific type of access control (role, permission, feature, or plan) and returns a boolean value. has() is available on the auth objectClerk Icon, which you will access differently depending on the framework you are usingClerk Icon.

The following example demonstrates how to use has() to check if a user has a plan.

src/bronze-content.vue
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'

const { isLoaded, has } = useAuth()
const hasBronzePlan = computed(() => has.value?.({ plan: 'bronze' }))
</script>

<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasBronzePlan">Only subscribers to the Bronze plan can access this content.</h1>
    <h1 v-else>For Bronze subscribers only</h1>
  </main>
</template>

The following example demonstrates how to use has() to check if a user has a feature.

src/premium-content.vue
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'

const { isLoaded, has } = useAuth()
const hasPremiumAccess = computed(() => has.value?.({ feature: 'premium_access' }))
</script>

<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasPremiumAccess">
      Only subscribers with the Premium Access feature can access this content.
    </h1>
    <h1 v-else>Our Exclusive Content</h1>
  </main>
</template>

Example: Using <Protect>

The <Protect> component protects content or even entire routes by checking if the user has been granted a specific type of access control (role, permission, feature, or plan). You can pass a fallback prop to <Protect> that will be rendered if the user does not have the access control.

The following example demonstrates how to use <Protect> to protect a page by checking if the user has a plan.

src/protected-content.vue
<script setup lang="ts">
import { Protect } from '@clerk/vue'
</script>

<template>
  <main>
    <Protect plan="bronze" fallback="Only subscribers to the Bronze plan can access this content.">
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Protect>
  </main>
</template>

The following example demonstrates how to use <Protect> to protect a page by checking if the user has a feature.

src/protected-premium-content.vue
<script setup lang="ts">
import { Protect } from '@clerk/vue'
</script>

<template>
  <main>
    <Protect
      feature="premium_access"
      fallback="Only subscribers with the Premium Access feature can access this content."
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Protect>
  </main>
</template>

Feedback

What did you think of this content?

Last updated on